Method: flights.computeFlightEmissions

  • This API calculates per-passenger flight emission estimates for direct flights.

  • Requests can contain up to 1000 flight legs and must include origin, destination, carrier code, flight number, and departure date.

  • Emission estimates are calculated based on the Google Travel Impact Model and may be unavailable for certain flights.

  • Results include emissions broken down by travel class (first, business, premium economy, economy) in grams per passenger.

  • The API response indicates the model version used for the calculations.

Retrieves emission estimates. Details on how emission estimates are computed are in GitHub.

The response will contain all entries that match the input flight legs, in the same order. If there are no estimates available for a certain flight leg, the response will return the flight leg object with empty emission fields. The request will still be considered successful. Reasons for missing emission estimates include:

  • The flight is unknown to the server.
  • The input flight leg is missing one or more identifiers.
  • The flight date is in the past.
  • The aircraft type is not supported by the model.
  • Missing seat configuration.

The request can contain up to 1000 flight legs. If the request has more than 1000 direct flights, if will fail with an INVALID_ARGUMENT error.

HTTP request

POST https://travelimpactmodel.googleapis.com/v1/flights:computeFlightEmissions

The URL uses gRPC Transcoding syntax.

Request body

The request body contains data with the following structure:

JSON representation
{
  "flights": [
    {
      object (Flight)
    }
  ]
}
Fields
flights[]

object (Flight)

Required. Direct flights to return emission estimates for.

Response body

Output definition for the flights.computeFlightEmissions response.

If successful, the response body contains data with the following structure:

JSON representation
{
  "flightEmissions": [
    {
      object (FlightWithEmissions)
    }
  ],
  "modelVersion": {
    object (ModelVersion)
  }
}
Fields
flightEmissions[]

object (FlightWithEmissions)

List of flight legs with emission estimates.

modelVersion

object (ModelVersion)

The model version under which emission estimates for all flights in this response were computed.

FlightWithEmissions

Direct flight with emission estimates.

JSON representation
{
  "flight": {
    object (Flight)
  },
  "source": enum (Source),
  "emissionsGramsPerPax": {
    object (EmissionsGramsPerPax)
  },
  "easaLabelMetadata": {
    object (EasaLabelMetadata)
  },
  "contrailsImpactBucket": enum (ContrailsImpactBucket)
}
Fields
flight

object (Flight)

Identifier. Matches the flight identifiers in the request. Note: all IATA codes are capitalized.

source

enum (Source)

Optional. The source of the emissions data.

emissionsGramsPerPax

object (EmissionsGramsPerPax)

Optional. Per-passenger emission estimate numbers. Will not be present if emissions could not be computed. For the list of reasons why emissions could not be computed, see flights.computeFlightEmissions.

easaLabelMetadata

object (EasaLabelMetadata)

Optional. Metadata about the EASA Flight Emissions Label. Only set when the emissions data source is EASA.

contrailsImpactBucket

enum (ContrailsImpactBucket)

Optional. The significance of contrails warming impact compared to the total CO2e emissions impact.